const _ = require('lodash');
const pluralize = require('pluralize');

const TYPE_TO_FAKER = {
	number: 'faker.random.number()',
	integer: 'faker.random.number()',
	string: 'faker.lorem.word()',
	boolean: 'faker.random.boolean()',
	array: '[]',
	object: '{}',
	null: 'null'
};

const ReadTemplate = (wordForms, properties) => {
	const propertyTitles = Object.keys(_.omit(properties, 'id')); // omit id

	const tplHeader = `
		var _ = require('lodash');
		var faker = require('faker');

		var ${wordForms.plural.lowerFirst} = _.times(100, function(n) {
		    return {
		        id: n,
		    `;

	let tplBody = ``;

	for (var i = 0; i < propertyTitles.length; i++) {
		let proprtyTtile = propertyTitles[i];
		let propertyType = properties[proprtyTtile].type || 'number';

		tplBody += `
			${proprtyTtile}: ${TYPE_TO_FAKER[propertyType]},
		`;
	}

	const tplFooter = `
		    };
		});

		module.exports = ${wordForms.plural.lowerFirst};
	`;

	return '' + tplHeader + tplBody + tplFooter;
};

module.exports = ReadTemplate;
