const _ = require('lodash');
const pluralize = require('pluralize');

const ReducersIndexTemplate = entities => {
	let tplImports = ``;
	let tplExports = ``;

	for (var i = 0; i < entities.length; i++) {
		let plural = pluralize.plural(_.lowerFirst(entities[i]));

		tplImports += `	var ${plural} = require('./${plural}');
`;

		tplExports += `
		${plural}: ${plural},`;
	}

	const tplHeader = `
module.exports = function() {
`;

	const tplMiddle = `
	return {`;

	const tplFooter = `
	};
};
`;

	return '' + tplHeader + tplImports + tplMiddle + tplExports + tplFooter;
};

module.exports = ReducersIndexTemplate;
