const _ = require('lodash');
const pluralize = require('pluralize');
const url = require('url');

const ActionTemplate = (wordForms, properties, urlBase = '') => `
	export const get${wordForms.plural.upperFirst} = query => {
	    return {
	        type: 'GET_${wordForms.plural.snakeCase.toUpperCase()}',
	        url: '${urlBase}/${wordForms.plural.kebabCase}',
	        method: 'get',
	        query: query
	    };
	};
`;

module.exports = ActionTemplate;
