const _ = require('lodash');
const pluralize = require('pluralize');

const ListTemplate = (wordForms, properties) => {
	const propertyTitles = Object.keys(properties);

	let tplHeader = `
		import React, { Component } from 'react';

		export default class ${wordForms.plural.upperFirst}List extends Component {
			render() {
				return (
					<tr key={this.props.${wordForms.singular.lowerFirst}.id}>
		`;

	let tplBody = ``;

	for (var i = 0; i < propertyTitles.length; i++) {
		let proprtyTtile = propertyTitles[i];

		switch (properties[proprtyTtile].type) {
			case 'boolean':
				tplBody += `
						<td>
							<div className="checkbox">
								<label>
									<input type="checkbox" checked={this.props.${wordForms.singular.lowerFirst}.${proprtyTtile}} disabled />
								</label>
							</div>
						</td>
		`;
				break;
			default:
				tplBody += `				<td>{this.props.${wordForms.singular.lowerFirst}.${proprtyTtile}}</td>
		`;
		}
	}

	tplBody += `
						<td width="1%"><a href={\`/${wordForms.plural.lowerFirst}/\${this.props.${wordForms.singular.lowerFirst}.id}\`} className="btn btn-small btn-default">Show</a></td>
						<td width="1%"><a href={\`/${wordForms.plural.lowerFirst}/\${this.props.${wordForms.singular.lowerFirst}.id}/edit\`} className="btn btn-small btn-primary">Edit</a></td>
						<td width="1%"><button className="btn btn-small btn-danger" disabled>Delete</button></td>`;

	const tplFooter = `
					</tr>
				);
			}
		}
	`;

	return '' + tplHeader + tplBody + tplFooter;
};

module.exports = ListTemplate;
