const _ = require('lodash');
const pluralize = require('pluralize');

const ReadTemplate = (wordForms, properties) => {
	const propertyTitles = Object.keys(properties);

	const tplHeader = `
		import React, { Component } from 'react';

		export default class ${wordForms.plural.upperFirst} extends Component {
			render() {
				return (
					<div className="${wordForms.singular.kebabCase}">
						<table className="table table-bordered table-hover">
							<thead>
								<tr>
									<th>Title</th>
									<th>Content</th>
								</tr>
							</thead>
							<tbody>
			`;

	let tplBody = ``;

	for (var i = 0; i < propertyTitles.length; i++) {
		let proprtyTtile = propertyTitles[i];

		tplBody += `
								<tr>
									<td><b>${proprtyTtile}</b></td>
									<td>{this.props.${wordForms.singular.camelCase}.${proprtyTtile}}</td>
								</tr>
				`;
	}

	const tplFooter = `
							</tbody>
						</table>
						<a href={\`/${wordForms.plural.lowerFirst}/\`} className="btn pull-left btn-default">Cancel</a>
						<a href={\`/${wordForms.plural.lowerFirst}/\${this.props.${wordForms.singular.lowerFirst}.id}/edit\`} className="btn btn-primary pull-right">Edit ${wordForms.plural.upperFirst}</a>
					</div>
				);
			}
		}
`;

	return '' + tplHeader + tplBody + tplFooter;
};

module.exports = ReadTemplate;
