const _ = require('lodash');
const pluralize = require('pluralize');

const CreateTemplate = (wordForms, properties) => {
	const propertyTitles = Object.keys(_.omit(properties, 'id')); // omit id

	const tplHeader = `
		import React, { Component } from 'react';

		export default class ${wordForms.singular.upperFirst}Create extends Component {
			render() {
				const {errors} = this.props;

				return (
					<div className="${wordForms.singular.kebabCase}">
						<form onSubmit={this.props.handleSubmit.bind(this)}>
			`;

	let tplBody = ``;

	for (var i = 0; i < propertyTitles.length; i++) {
		let proprtyTtile = propertyTitles[i];

		tplBody += `
							<div className="form-group">
								<label>${proprtyTtile}</label>
		`;

		if (properties[proprtyTtile]['$ref']) {
			tplBody += `<p>There should be $ref to ${properties[proprtyTtile]['$ref']}</p>`;
		} else {
			tplBody += getInputByType(properties[proprtyTtile].type, proprtyTtile);
		}

		tplBody += `						{(errors && errors.${proprtyTtile}) && <p className="text-danger">{errors.${proprtyTtile}}</p>}
							</div>
				`;
	}

	const tplFooter = `
							<button type="submit" className="btn btn-default">Create ${wordForms.singular.upperFirst}</button>
						</form>
					</div>
				);
			}
		}
	`;

	return '' + tplHeader + tplBody + tplFooter;
};

const getInputByType = (type, proprtyTtile) => {
	switch (type) {
		case 'boolean':
			return `
				<div className="checkbox">
					<label>
						<input type="checkbox" onChamge={e => { this.setState({${proprtyTtile}: !this.state.${proprtyTtile}}) }} /> ${proprtyTtile}
					</label>
				</div>
			`;

		case 'number':
		case 'integer':
			return `
				<input
					type="number"
					className="form-control"
					placeholder="${proprtyTtile}"
					onChange={e => {
						this.setState({
							${proprtyTtile}: e.target.value
						});
					}}
				/>
			`;

		case 'string':
			return `
				<input
					type="text"
					className="form-control"
					placeholder="${proprtyTtile}"
					onChange={e => {
						this.setState({
							${proprtyTtile}: e.target.value
						});
					}}
				/>
			`;
	}
};

module.exports = CreateTemplate;
