const _ = require('lodash');

const UpdateTemplate = (wordForms, properties) => {
	const propertyTitles = Object.keys(_.omit(properties, 'id')); // omit id

	const tplHeader = `
		import React, { Component } from 'react';

		export default class ${wordForms.singular.upperFirst} extends Component {
			handleSubmit(e) {
				e.preventDefault();

				this.props.update${wordForms.singular.upperFirst}(this.props.${wordForms.singular.lowerFirst}.id, this.props.${wordForms.singular.lowerFirst});
			}

			render() {
				return (
					<div className="${wordForms.singular.kebabCase}">
						<form onSubmit={this.handleSubmit.bind(this)}>
			`;

	let tplBody = ``;

	for (var i = 0; i < propertyTitles.length; i++) {
		let proprtyTtile = propertyTitles[i];

		tplBody += `
							<div className="form-group">
								<label>${proprtyTtile}</label>
								<input
									type="text"
									className="form-control"
									placeholder="${proprtyTtile}"
									value= {this.props.${wordForms.singular.lowerFirst}.${proprtyTtile}}
									onChange={e => {
										this.props.set${wordForms.singular.upperFirst}(Object.assign({}, this.props.${wordForms.singular.lowerFirst}, {${proprtyTtile}: e.target.value}));
									}}
								/>

								{
									(this.props.${wordForms.singular.lowerFirst}.errors && this.props.${wordForms.singular.lowerFirst}.errors.${proprtyTtile}) &&
									<p className="text-danger">{this.props.${wordForms.singular.lowerFirst}.errors.${proprtyTtile}}</p>
								}
							</div>
				`;
	}

	const tplFooter = `
							<a href={\`/${wordForms.plural.lowerFirst}/\`} className="btn pull-left btn-default">Cancel</a>
							<button type="submit" className="btn btn-primary pull-right">Update ${wordForms.singular.upperFirst}</button>
						</form>
					</div>
				);
			}
		}
	`;

	return '' + tplHeader + tplBody + tplFooter;
};

module.exports = UpdateTemplate;
