const _ = require('lodash');
const pluralize = require('pluralize');

const ReducersIndexTemplate = entities => {
	const tplHeader = `
		import React, { Component } from 'react';
		import { Link } from 'react-router-dom';

		export default class IndexPage extends Component {
			render() {
				return (
					<div className="row">
						<div className="col-md-12">
							<div className="list-group">
		`;

	let tplBody = ``;

	for (var i = 0; i < entities.length; i++) {
		let singular = pluralize.singular(entities[i]);
		let plural = pluralize.plural(entities[i]);

		let capitalized = _.upperFirst(singular);
		let capitalizedPlural = _.upperFirst(plural);

		let href = _.kebabCase(plural);

		tplBody += `
								<Link to="/${href}" className="list-group-item">${capitalizedPlural}</Link>

		`;
	}

	const tplFooter = `
							</div>
						</div>
					</div>
				);
			}
		}
	`;

	return '' + tplHeader + tplBody + tplFooter;
};

module.exports = ReducersIndexTemplate;
