const _ = require('lodash');
const pluralize = require('pluralize');

const ListTemplate = (wordForms, properties) => {
	const propertyTitles = Object.keys(properties);

	let tableHead = ``;

	for (var i = 0; i < propertyTitles.length; i++) {
		let proprtyTtile = propertyTitles[i];

		tableHead += `<th>${_.upperFirst(proprtyTtile)}</th>
							`;
	}

	let template = `
		import React, { Component }   from 'react';
		import PropTypes              from 'prop-types';
		import { bindActionCreators } from 'redux';
		import { connect }            from 'react-redux';

		import * as ${wordForms.plural.lowerFirst}Actions from '../actions/${wordForms.plural.lowerFirst}';

		import ${wordForms.plural.upperFirst} from '../components/${wordForms.plural.upperFirst}';

		export class ${wordForms.plural.upperFirst}Page extends Component {

			componentWillMount() {
				this.props.get${wordForms.plural.upperFirst}();
			}

			render() {
				return (
					<div className="${wordForms.plural.kebabCase}-page">
						<table className="table table-bordered table-hover">
							<thead>
								<tr>
									${tableHead}
									<th colSpan="3" />
								</tr>
							</thead>
							<tbody>
								{this.props.${wordForms.plural.lowerFirst} && this.props.${wordForms.plural.lowerFirst}.map(${wordForms.singular.lowerFirst} => <${wordForms.plural.upperFirst} key={${wordForms.singular.lowerFirst}.id} ${wordForms.singular.lowerFirst} = {${
		wordForms.singular.lowerFirst
	}} />)}
							</tbody>
						</table>
					</div>
				);
			}
		}

		${wordForms.plural.upperFirst}Page.contextTypes = {
		  router: PropTypes.object.isRequired
		};

		const mapStateToProps = ({${wordForms.plural.lowerFirst}}) => ({${wordForms.plural.lowerFirst}});
		const mapDispatchToProps = dispatch => bindActionCreators(${wordForms.plural.lowerFirst}Actions, dispatch);

		export default connect(mapStateToProps, mapDispatchToProps)(${wordForms.plural.upperFirst}Page);
	`;

	return '' + template;
};

module.exports = ListTemplate;
