const _ = require('lodash');
const pluralize = require('pluralize');

const CreatePageTemplate = (wordForms, properties) => `
	import React, { Component }   from 'react';
	import PropTypes              from 'prop-types';
	import { bindActionCreators } from 'redux';
	import { connect }            from 'react-redux';

	import * as ${wordForms.singular.lowerFirst}Actions from '../actions/${wordForms.singular.lowerFirst}';

	import ${wordForms.singular.upperFirst}Create from '../components/${wordForms.singular.upperFirst}Create';

	export class ${wordForms.singular.upperFirst}CreatePage extends Component {
		render() {
			return (
				<div className="${wordForms.singular.kebabCase}-create-page">
					<${wordForms.singular.upperFirst}Create ${wordForms.singular.lowerFirst}={this.props.${wordForms.singular.lowerFirst}} handleSubmit={this.props.create${wordForms.singular.upperFirst}} />
				</div>
			);
		}
	}

	${wordForms.singular.upperFirst}CreatePage.contextTypes = {
	  router: PropTypes.object.isRequired
	};

	const mapStateToProps = ({${wordForms.singular.lowerFirst}}) => ({${wordForms.singular.lowerFirst}});
	const mapDispatchToProps = dispatch => bindActionCreators(${wordForms.singular.lowerFirst}Actions, dispatch);

	export default connect(mapStateToProps, mapDispatchToProps)(${wordForms.singular.upperFirst}CreatePage);
`;

module.exports = CreatePageTemplate;
