const _ = require('lodash');
const pluralize = require('pluralize');

const UpdatePageTemplate = (wordForms, properties) => `
	import React, { Component }   from 'react';
	import PropTypes              from 'prop-types';
	import { bindActionCreators } from 'redux';
	import { connect }            from 'react-redux';

	import * as ${wordForms.singular.lowerFirst}Actions from '../actions/${wordForms.singular.lowerFirst}';

	import ${wordForms.singular.upperFirst}Update from '../components/${wordForms.singular.upperFirst}Update';

	export class ${wordForms.singular.upperFirst}UpdatePage extends Component {

		componentWillMount() {
			this.fetchData();
		}

		componentDidUpdate(prevProps) {
			(this.props.match.params.id !== prevProps.match.params.id) && this.fetchData();
		}

		fetchData() {
			this.props.get${wordForms.singular.upperFirst}(this.props.match.params.id);
		}

		render() {
			return (
				<div className="${wordForms.singular.kebabCase}-update-page">
					{this.props.${wordForms.singular.lowerFirst} && <${wordForms.singular.upperFirst}Update ${wordForms.singular.lowerFirst}={this.props.${wordForms.singular.lowerFirst}} set${wordForms.singular.upperFirst}={this.props.set${
	wordForms.singular.upperFirst
}} update${wordForms.singular.upperFirst}={this.props.update${wordForms.singular.upperFirst}} />}
				</div>
			);
		}
	}

	${wordForms.singular.upperFirst}UpdatePage.contextTypes = {
		router: PropTypes.object.isRequired
	};

	const mapStateToProps = ({${wordForms.singular.lowerFirst}}) => ({${wordForms.singular.lowerFirst}});
	const mapDispatchToProps = dispatch => bindActionCreators(${wordForms.singular.lowerFirst}Actions, dispatch);

	export default connect(mapStateToProps, mapDispatchToProps)(${wordForms.singular.upperFirst}UpdatePage);
`;

module.exports = UpdatePageTemplate;
