const _ = require('lodash');
const pluralize = require('pluralize');

const ReducerTemplate = wordForms => `
	const INITIAL_STATE = null;

	export default (state = INITIAL_STATE, {type, data, errors}) => {

		switch (type) {
			case 'GET_${wordForms.singular.snakeCase.toUpperCase()}_START':
				return INITIAL_STATE;
			case 'SET_${wordForms.singular.snakeCase.toUpperCase()}':
			case 'GET_${wordForms.singular.snakeCase.toUpperCase()}_SUCCESS':
			case 'CREATE_${wordForms.singular.snakeCase.toUpperCase()}_SUCCESS':
			case 'UPDATE_${wordForms.singular.snakeCase.toUpperCase()}_SUCCESS':
				return {
					...data,
					errors: null
				};
			case 'CREATE_${wordForms.singular.snakeCase.toUpperCase()}_FAILED':
			case 'UPDATE_${wordForms.singular.snakeCase.toUpperCase()}_FAILED':
				return {...state, errors};
			default:
				return state;
		}

	};
`;

module.exports = ReducerTemplate;
