const _ = require('lodash');
const pluralize = require('pluralize');

const ReducersIndexTemplate = entities => {
	let tplImports = ``;
	let tplExports = ``;

	const tplHeader = `import { combineReducers } from 'redux';`;

	for (var i = 0; i < entities.length; i++) {
		const singular = pluralize.singular(entities[i]);
		const plural = pluralize.plural(entities[i]);

		const lowerized = _.lowerFirst(singular);
		const lowerizedPlural = _.lowerFirst(plural);

		tplImports += `
			import ${lowerized} from './${lowerized}';
			import ${lowerizedPlural} from './${lowerizedPlural}';
		`;

		tplExports += `
			${lowerized},
			${lowerizedPlural},
		`;
	}

	const tplMiddle = `export default combineReducers({`;
	const tplFooter = `});`;

	return '' + tplHeader + tplImports + tplMiddle + tplExports + tplFooter;
};

module.exports = ReducersIndexTemplate;
