const _ = require('lodash');
const pluralize = require('pluralize');

const RoutesTemplate = entities => `
	import React from 'react';
	import { Provider } from 'react-redux';
	import { BrowserRouter as Router, Route } from 'react-router-dom';

	import IndexPage from "./containers/IndexPage";

	import store from './store';

	${entities
		.map(
			entity => `
		import Page${_.upperFirst(pluralize.plural(entity))} from './containers/Page${_.upperFirst(pluralize.plural(entity))}';
		import Page${_.upperFirst(pluralize.singular(entity))} from './containers/Page${_.upperFirst(pluralize.singular(entity))}';
		import Page${_.upperFirst(pluralize.singular(entity))}Create from './containers/Page${_.upperFirst(pluralize.singular(entity))}Create';
		import Page${_.upperFirst(pluralize.singular(entity))}Update from './containers/Page${_.upperFirst(pluralize.singular(entity))}Update';
	`
		)
		.join('')}

	export default (
		<Provider store={store}>
			<Router>
				<div>
					<Route exact path="/" component={IndexPage}/>

					${entities
						.map(
							entity => `
						<Route exact path = "/${_.lowerFirst(pluralize.plural(entity))}"            component = { Page${_.upperFirst(pluralize.plural(entity))} }/>
						<Route exact path = "/${_.lowerFirst(pluralize.plural(entity))}/new"        component = { Page${_.upperFirst(pluralize.singular(entity))}Create } />
						<Route exact path = "/${_.lowerFirst(pluralize.plural(entity))}/:id"        component = { Page${_.upperFirst(pluralize.singular(entity))} } />
						<Route exact path = "/${_.lowerFirst(pluralize.plural(entity))}/:id/edit"   component = { Page${_.upperFirst(pluralize.singular(entity))}Update } />
					`
						)
						.join('')}
				</div>
			</Router>
		</Provider>
	)
`;

module.exports = RoutesTemplate;
